﻿var shell = null;

var sz = 0;

function view_onOpen() {
   options.putDefaultValue("border", "0");
   options.putDefaultValue("sz", "24");
   div2.visible = !(showCaptionAlways = (options.getValue("border") == "1"));
   sz = options.getValue("sz") * 1;
   shell = new ActiveXObject("Wscript.Shell");
   InitShortCuts();
   repaintIcons(1, -1);
   resizable = true;
}

function view_onSize() {
   div1.width = width;
   div1.height = height;
   repaintIcons(0, -1);
}

function pluginHelper.onAddCustomMenuItems(menu) 
{
   menu.AddItem(STR_CA, 0, clearAll);
   menu.AddItem(STR_SHOWB, showCaptionAlways ? gddMenuItemFlagChecked : 0, tickBorder);  
   var menis = menu.AddPopup(STR_ICONSZ);
   menis.AddItem(STR_TINY, (sz == 16) ? gddMenuItemFlagChecked : 0, function () {setsz(16);});
   menis.AddItem(STR_MEDIUM, (sz == 24) ? gddMenuItemFlagChecked : 0, function () {setsz(24);});
   menis.AddItem(STR_LARGE, (sz == 32) ? gddMenuItemFlagChecked : 0, function () {setsz(32);});
   menis.AddItem(STR_HUGE, (sz == 64) ? gddMenuItemFlagChecked : 0, function () {setsz(64);});
}

function setsz(nsz)
{
	sz = nsz;
    repaintIcons(0, -1);
    options.putValue("sz", sz);
}

function clearAll()
{
   if (confirm(STR_AREUSUREDELETE))
   {
     ClearShortCuts();
	 repaintIcons(0, -1);
   }
}

function tickBorder()
{
   div2.visible = !(showCaptionAlways = !showCaptionAlways);
   options.putValue("border", showCaptionAlways ? "1" : "0");
}

function mov()
{
   if (event.srcElement.colorMultiply)
     event.srcElement.colorMultiply = "#a8b3c3";
}

function mou()
{
   if (event.srcElement.colorMultiply)
     event.srcElement.colorMultiply = "#00000000";
}

function getselInd(x, y)
{
    var inx = Math.floor(div1.width / (sz+1));
	var px = Math.floor(x / sz);
	var py = Math.floor(y / sz); 

	var res = py * inx + px;
    
	return res < shortcuts.length ? res : -1;
}

var eee = null;
var eee2 = false;
var ex = 0, ey = 0;
var eeei = -1;

function mod()
{
	if (event.button == 1)
	{
		eee = event.srcElement;
		eeei = getselInd(event.x + eee.x, event.y + eee.y);

		if (eeei < 0)
        {
			eeei = -1;
			eee = null;
		}

		repaintIcons(0, eeei);

		ex = event.x;
		ey = event.y;
	}

}

function div1_onMouseMove()
{
    if (eee != null && event.button == 1)
	{
        eee2 = true;
		eee.x = (event.srcElement.src ? event.x + event.srcElement.x : event.x) - ex;
		eee.y = (event.srcElement.src ? event.y + event.srcElement.y : event.y) - ey;
		eee.visible = eee.x + ex >= 0 && eee.y + ey >= 0;
	}
	else
	{
	    eee2 = false;
	}
}

function div1_onMouseUp()
{
	if (event.button == 1 && eee2)
	{
		var si = getselInd(event.x + event.srcElement.x, event.y + event.srcElement.y);

		if (si >= 0)	
			SwapShortcuts(eeei, si);
		else if (si == -1)
			SwapShortcuts(eeei, shortcuts.length - 1);
		else
			DeleteShortcut(eeei);

		eee = null;
		repaintIcons(0, -1);
	}
	else if (event.button == 2)
	{
		var eee = event.srcElement;
		var si = getselInd(event.x + eee.x, event.y + eee.y);	
		if (si >= 0)
			ren(eeei);
	}
}

function ren(itm)
{
	var nn = null;
    try
	{
		nn = prompt(STR_ENTERNAME, shortcuts[itm].name);
	}
	catch (e)
	{
		nn = my_prompt(STR_ENTERNAME, GADGET_NAME, shortcuts[itm].name);
	}

	if (nn != null && nn != '')
		RenameShortcut(itm, nn);

	repaintIcons(0, -1);
}

function gen_img(i, inx, iny)
{
	var fn = shortcuts[i].file;
	var titl = shortcuts[i].name;
    var code = "<img tooltip='" + titl + "' width='" + sz + "' cursor='hand' height='" + sz + "' src='" + framework.system.getFileIcon(fn) + "' enabled='true' />"; 
    var elem = div1.appendElement(code);
    
	elem.onclick = new Function("if (!eee2) run('" + fn.escape() + "');");
    elem.x = (i % inx) * (sz+1);
    elem.y = Math.floor(i / inx) * (sz+1);
    elem.onmouseover = mov;
    elem.onmouseout = mou;
    elem.onmousedown = mod;
    elem.onmousemove = div1_onMouseMove;
	elem.onmouseup = div1_onMouseUp;

	return elem;
}

function repaintIcons(v, ei)
{
    var inx = Math.floor(div1.width / (sz+1));
    var iny = Math.floor(div1.height / (sz+1));
    div1.removeAllElements();
	for (i = 0; i < shortcuts.length; i++)
	{
		if (i == ei)
			continue;
		gen_img(i, inx, iny);
	}

	if (ei >= 0)
	{
		eee = gen_img(ei, inx, iny);
	}

    if (v == 1)
    {
	    resizable = false;
        var nr = Math.ceil(shortcuts.length / inx);
        if (height < nr * sz + 6)
		     height = nr * sz + 6;
		resizable = true;
    }

   label1.visible = shortcuts.length < 1;
}

function run(what)
{
   try
   {
      shell.run('"' + what + '"');
   }
   catch (e)
   {
      alert(e);
   }
}

function div1_ondragover() {
	event.returnValue = (event.dragFiles.count > 0);
}

function div1_ondragdrop() {
  for (i = 0; i < event.dragFiles.count; i++)
  {
    var fn = event.dragFiles.item(i) + '';
    NewShortCut(fn.lastpath(), fn);
  }	
  repaintIcons(0, -1);
  event.returnValue = true;
}
