﻿function Shortcut(aname, afile)
{
   this.name = aname;
   this.file = afile;
}

var shortcuts;

function InitShortCuts()
{
   shortcuts = new Array();
   if (options.exists("shortcut_list"))
   {
		var stor = options.getValue("shortcut_list");
        shortcuts = stor.parseJSON();
   }
}

function _savesc()
{
   options.putValue("shortcut_list", shortcuts.toJSONString());
}

function NewShortCut(aname, afile)
{
   shortcuts.push(new Shortcut(aname, afile));
   _savesc();
}

function ClearShortCuts()
{
     shortcuts = new Array();
     _savesc();
}

function SwapShortcuts(a, b)
{
	if (a == b)
		return;
    var tmp = shortcuts[a];
	shortcuts.splice(a, 1);
	shortcuts.splice(b, 0, tmp);
	shortcuts[b] = tmp;
	_savesc();
}

function DeleteShortcut(ind)
{
	shortcuts.splice(ind, 1);
	_savesc();
}

function RenameShortcut(ind, nn)
{
	shortcuts[ind].name = nn;
	_savesc();	
}
